Keccak Class Reference

Keccak message digest base class. More...

`#include <keccak.h>`

Inheritance diagram for Keccak:

## Public Member Functions

unsigned int | DigestSize () const
| Provides the digest size of the hash.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | Restart ()
| Restart the hash.
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Detailed Description

Keccak message digest base class.

The Crypto++ Keccak implementation uses F1600 with XOF d=0x01. FIPS 202 conformance (XOF d=0x06) is available in SHA3 classes.

Keccak is the base class for Keccak_224, Keccak_256, Keccak_384 and Keccak_512. Library users should instantiate a derived class, and only use Keccak as a base class reference or pointer.

Keccak will likely change in the future to accommodate extensibility of the round function and the XOF functions.

Perform the following to specify a different digest size. The class will use F1600, XOF d=0x01, and a new value for r() (which will be 200-2*24 = 152).

      Keccack_192 : public Keccack
      {
        public:
          CRYPTOPP_CONSTANT(DIGESTSIZE = 24);
          Keccack_192() : Keccack(DIGESTSIZE) {}
      };

See also
  SHA3, Keccak_224, Keccak_256, Keccak_384 and Keccak_512.

Since
  Crypto++ 5.6.4

Definition at line 40 of file keccak.h.

## Member Function Documentation

## DigestSize()

unsigned int Keccak::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 54 of file keccak.h.

## OptimalDataAlignment()

unsigned int Keccak::OptimalDataAlignment | ( |  | ) | const

inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 55 of file keccak.h.

## Update()

void Keccak::Update | ( | const byte * | input,
|  | size_t | length )

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 28 of file keccak.cpp.

## Restart()

void Keccak::Restart | ( |  | ) |

virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 49 of file keccak.cpp.

## TruncatedFinal()

void Keccak::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize )

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  COUNTOF(digest) <= DigestSize() or COUNTOF(digest) <= HASH::DIGESTSIZE ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 55 of file keccak.cpp.

The documentation for this class was generated from the following files:

- keccak.h
- keccak.cpp